// ============================
// Working with Delphi classes.
// ============================

// LMD Script Control allows you to work with Delphi classes.
// You can create and destroy objects in script, access to its
// public interface: call methods, access fields and properties.
// Script Control supports properties with parameters.
// Script Control fully supports Delphi metaclasses, including
// storing references to metaclasses in script variables and
// polimorphic calls of virtual metaclass methods.
//
// Note: PascalScript suports native 'is' operator to test 
//       object class. There are no need to use ObjectIs 
//       function.

procedure Main;
var
  form, memo, cls;
  formcls, form2;
begin
    // Create new form with a memo:

    form          := TForm.Create(Application);
    form.Caption  := 'Delphi Class Usage Demo';
    form.Position := poScreenCenter;

    memo          := TMemo.Create(form);
    memo.Parent   := form;
    memo.Align    := alClient;
    memo.Lines.Add('Hellow from script :)');

    form.ShowModal;

    // Metaclass usage:

    MessageList.Lines.Add('Created form class is: ' + form.ClassType.ClassName);

    cls := TComponent;
    if form is cls then  
        MessageList.Lines.Add('Our form is TComponent');

    if form is TForm then
        MessageList.Lines.Add('Our form is TForm as well');

    // Create an object using metaclass reference
    // and virtual constructor: 

    formcls := TForm;
    form2   := formcls.Create(Application);

    form2.Free;      // Don't show this form,
                     // just destroy it.
end;