' ============================
' Working with Delphi records.
' ============================

' LMD Script Control allows you to work with Delphi records.
' Since COM model does not provide adequate record (struct)
' abstraction, script control uses special objects to represent
' record values inside script. So, for example, you must use
' 'set' keyword in MS VBScript when working with records. As with
' any object, you must create a record instance before it can
' be used. Use implicitly addded Create constructor for 
' creating record instances. Also use implicitly added Copy method 
' to make a record copy.

sub Main
    'Creating and using records:

    dim rec = new TPoint
    rec.X = 3
    rec.Y = 5
    dim recstr = "(" + CStr(rec.X) + ", " + CStr(rec.Y) + ")"

    MessageList.Lines.Add "Created TPoint record: " + recstr

    'Copying records:

    dim samerec    = rec      'Just another ref to same record object.
    dim anotherrec = rec.Copy 'Real copy.

    'Record type testing:

    if typeof rec is TPoint then
        MessageList.Lines.Add "Record is TPoint"
    end if

    if not (typeof rec is TRect) then
        MessageList.Lines.Add "Record is not TRect"
    end if
end sub
