' =================================
' Working with Delphi sets.
' =================================

' LMD Script Control allows you to work with Delphi sets.
' In COM type model sets are represented as numbers. So,
' script control supports only sets with:
' SizeOf(<SetType>) <= SizeOf(Integer).
' Hovewer, almost all VCL sets fit in this restriction.

sub Main
    'Create a form and change some of it's set properties:

    dim form         = TForm.Create(Application)
    form.Caption     = "LMD Script Control Sets Demo"
    form.Position    = poScreenCenter
    form.BorderIcons = SetMake(biSystemMenu, biMinimize)
    form.Font.Style  = SetEmpty
    form.ShowModal

    'More sets examples:

    dim s = SetEmpty
    Include s, fsBold

    if SetIn(fsBold, s) then
        MessageList.Lines.Add "Set variable 's' includes 'fsBold'"
    end if

    if not SetIn(fsItalic, s) then
        MessageList.Lines.Add "Set variable 's' does not includes 'fsItalic'"
    end if
end sub
