' =================================
' Working with Delphi events.
' =================================

' LMD Script Control allows you to work with Delphi events.
' Script control uses special objects to represent event
' handler reference values inside script. So, for example,
' you must use 'set' keyword in VBScript when working with
' events. Special EventMake function should be used to
' associate script procedure with some event.

sub Main
    dim form      = TForm.Create(Application)
    form.Caption  = "LMD Script Control Events Demo"
    form.Position = poScreenCenter
    form.OnClose  = EventMake("Form_Close")

    dim btn       = TButton.Create(form)
    btn.Left      = 20
    btn.Top       = 20
    btn.Parent    = form
    btn.Caption   = "Click me"
    btn.OnClick   = EventMake("Btn_Click")

    form.ShowModal
end sub

sub Form_Close(Sender, byref Action)
    MessageList.Lines.Add "Form closed."
end sub

sub Btn_Click(Sender)
    MessageList.Lines.Add "Button clicked."
end sub
